<!DOCTYPE html>
<html>
	<head>
		<title>Le fonctionnement des clauses SQL</title>
		<base href="/" />
		<meta charset="UTF-8"/>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta name="viewport" content="width=device-width, maximum-scale=1, user-scalable=1" />
		<style>
			/* Votre mise en forme au besoin */
			body{ font-family: Arial; }
			h1{ text-align: center; }
			table{ margin: auto; border-collapse: collapse; border: solid 1px #000; }
			table th, table td{ padding: .5em; border: solid 1px #000; border-top: none; border-bottom: dotted 1px #000; }
			table th{ background: rgb(79,129,189); color: #fff; font-weight: normal; text-align: center; }
			table tbody>tr:nth-child(2n)>td{ background: rgb(184,204,228); }
			table td{ text-align: left; background: #fff; }
			.block{ margin: auto; padding-top: .5em; padding-bottom: 2em; text-align: center; }
			.block:nth-child(2n){ background: rgb(238,243,248); }
			ul{ display: inline-block; margin: auto; text-align: left; }
		</style>
	</head>
	<body>
			
			<h1>TP N°3 - comprendre le fonctionnement des clauses SQL (Rappel et/ou aide PHP)</h1>
			
			<div class="block">
				<h2>Manipulation des tableaux</h2>
				Exemples : $tableau = array(1,2,3,4); <br/>
				<?php $tableau = array(1,2,3,4)?>
				<br/>
				<table>
					<thead>
						<tr>
							<th>Description</th>
							<th>Test</th>
							<th>Résultat</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td>Concaténer les éléments d'un tableau pour en faire une chaîne avec un séparateur :</td>
							<td>echo implode(', ', $tableau)</td>
							<td><?=implode(', ', $tableau);?></td>
						</tr>
						<tr>
							<td>Ajouter un élément :</td>
							<td>$tableau[] = 5;</td>
							<td>array(<?=implode(', ', $tableau);?>)</td>
						</tr>
						<tr>
							<td>Afficher le 3-ième élément du tableau :</td>
							<td>echo $tableau[3]</td>
							<td><?=$tableau[3]?></td>
						</tr>
						<tr>
							<td>Modification du 3-ième élément du tableau :</td>
							<td>$tableau[3] = 7</td>
							<td>
								<?php $tableau[3] = 7; ?>
								array(<?=implode(', ', $tableau);?>)
							</td>
						</tr>
						<tr>
							<td>Taille (nombre d'éléments) d'un tableau :</td>
							<td>echo count($tableau)</td>
							<td><?=count($tableau)?></td>
						</tr>
					</tbody>
				</table>
			</div>
			
			<div class="block">
				<h2>Tester le typage d'une variable et autre tests</h2>
				Exemples : <br/>
				<br/>
				<ul>
					<li>$tableau = array(1,2,3,4); </li>
					<li>$chaine = 'une chaîne'; </li>
					<li>$nombre = 777; </li>
					<li>$booleen = true; </li>
				</ul>
				<br/>
				<?php
					$tableau = array(1,2,3,4); 
					$chaine = 'une chaîne'; 
					$nombre = 777; 
					$booleen = true; 
				?>
				<br/>
				<table>
					<thead>
						<th>Variable</th>
						<th>is_array($variable)</th>
						<th>is_int($variable)</th>
						<th>is_numeric($variable)</th>
						<th>is_bool($variable)</th>
						<th>$variable == true</th>
						<th>$variable === true</th>
						<th>$variable != true</th>
						<th>$variable !== true</th>
					</thead>
					<tbody>
						<tr>
							<td>$tableau</td>
							<td><?=is_array($tableau) ? 'true' : 'false'?></td>
							<td><?=is_int($tableau) ? 'true' : 'false'?></td>
							<td><?=is_numeric($tableau) ? 'true' : 'false'?></td>
							<td><?=is_bool($tableau) ? 'true' : 'false'?></td>
							<td><?=($tableau == true) ? 'true' : 'false'?></td>
							<td><?=($tableau === true) ? 'true' : 'false'?></td>
							<td><?=($tableau != true) ? 'true' : 'false'?></td>
							<td><?=($tableau !== true) ? 'true' : 'false'?></td>
						</tr>
						<tr>
							<td>$chaine</td>
							<td><?=is_array($chaine) ? 'true' : 'false'?></td>
							<td><?=is_int($chaine) ? 'true' : 'false'?></td>
							<td><?=is_numeric($chaine) ? 'true' : 'false'?></td>
							<td><?=is_bool($chaine) ? 'true' : 'false'?></td>
							<td><?=($chaine == true) ? 'true' : 'false'?></td>
							<td><?=($chaine === true) ? 'true' : 'false'?></td>
							<td><?=($chaine != true) ? 'true' : 'false'?></td>
							<td><?=($chaine !== true) ? 'true' : 'false'?></td>
						</tr>
						<tr>
							<td>$nombre</td>
							<td><?=is_array($nombre) ? 'true' : 'false'?></td>
							<td><?=is_int($nombre) ? 'true' : 'false'?></td>
							<td><?=is_numeric($nombre) ? 'true' : 'false'?></td>
							<td><?=is_bool($nombre) ? 'true' : 'false'?></td>
							<td><?=($nombre == true) ? 'true' : 'false'?></td>
							<td><?=($nombre === true) ? 'true' : 'false'?></td>
							<td><?=($nombre != true) ? 'true' : 'false'?></td>
							<td><?=($nombre !== true) ? 'true' : 'false'?></td>
						</tr>
						<tr>
							<td>$booleen</td>
							<td><?=is_array($booleen) ? 'true' : 'false'?></td>
							<td><?=is_int($booleen) ? 'true' : 'false' ? 'true' : 'false'?></td>
							<td><?=is_numeric($booleen)?></td>
							<td><?=is_bool($booleen) ? 'true' : 'false'?></td>
							<td><?=($booleen == true) ? 'true' : 'false'?></td>
							<td><?=($booleen === true) ? 'true' : 'false'?></td>
							<td><?=($booleen != true) ? 'true' : 'false'?></td>
							<td><?=($booleen !== true) ? 'true' : 'false'?></td>
						</tr>
					</tbody>
				</table>
			</div>
			
			<div class="block">
				<h2>Manipuler les chaînes de caractères</h2>
				
				<table>
					<thead>
						<th>Description</th>
						<th>Test</th>
						<th>Résultat</th>
					</thead>
					<tbody>
						<tr>
							<td>"Split" une chaîne en un tableau en fonction d'un séparateur</td>
							<td>
								$chaine = explode(',', 'a,b,c,d,e,f'); <br/>
								echo $chaine[0] . ' - ' . $chaine[5];
							</td>
							<td>
								<?php
									$chaine = explode(',', 'a,b,c,d,e,f'); 
									echo $chaine[0] . ' - ' . $chaine[5];
								?>
							</td>
						</tr>
						<tr>
							<td>Extraire une sous chaîne, en l'occurrence les 5 premiers caractères d'une chaîne</td>
							<td>echo substr('COUNT(bonjour)', 0, 5);</td>
							<td><?=substr('COUNT(bonjour)', 0, 5)?></td>
						</tr>
						<tr>
							<td>Taille d'une chaîne</td>
							<td>echo strlen('COUNT(bonjour)');</td>
							<td><?=strlen('COUNT(bonjour)')?></td>
						</tr>
						<tr>
							<td>Affiche le 1er et le dernier caractère d'une chaîne</td>
							<td>
								$chaine = "aBcDeF"; <br/>
								$n = strlen($chaine); <br/>
								echo '1er caractère : ' . $chaine[0] . '&lt;br&gt;'; <br/>
								echo $n . '-ième caractère : ' . $chaine[$n-1];
							</td>
							<td>
								<?php
									$chaine = "aBcDeF";
									$n = strlen($chaine);
									echo '1er caractère : ' . $chaine[0] . '<br/>';
									echo $n . '-ième caractère : ' . $chaine[$n-1];
								?>
							</td>
						</tr>
					</tbody>
				</table>
			</div>
			
	</body>
</html>
